SET NAMES WIN1250 ;

CONNECT  "C:\PRZENOSZENIE OPLAT\1_OPSK_OLD\is_opsk.GDB" USER "SYSDBA" PASSWORD "masterkey";

SET TERM ^ ;

set autoddl on;
set sql dialect 1;

SET TERM ^ ;
ALTER TRIGGER LZ_TRG_LOG_INS_BEF
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  POST_EVENT 'NONE';
END
^
DROP TRIGGER TR_CHG_ADR^
DROP TRIGGER TR_CHG_FIZ^
DROP TRIGGER TR_CHG_PRAW^
DROP TRIGGER TR_INS_MAIN^

ALTER PROCEDURE BO_ATTACH (ID_SYSTEMU Smallint,
       ID_OSOBY   Integer,
       ID_ADRESU  Integer)
AS 
 BEGIN EXIT; END^

ALTER PROCEDURE BO_DELETE (ID_OSOBY  Integer,
       ID_ADRESU Integer)
AS 
 BEGIN EXIT; END^

ALTER PROCEDURE BO_DETACH (ID_SYSTEMU Smallint,
       ID_OSOBY   Integer,
       ID_ADRESU  Integer)
AS 
 BEGIN EXIT; END^

ALTER PROCEDURE BO_READALL (ST_NAZWA  Varchar(20),
       ST_MIASTO Varchar(20),
       ST_ULICA  Varchar(20))
returns (OSFIZ     Char(1),
         NAZWA     Char(120),
         ADRES     Char(110),
         ID_OSOBY  Integer,
         ID_ADRESU Integer,
         ID_KATEG  Integer)
AS 
 BEGIN EXIT; END^

ALTER PROCEDURE BO_READFRM (P_IDOS  Integer,
       P_IDADR Integer)
returns (NAZWA Char(120),
         ADRES Char(100))
AS 
 BEGIN EXIT; END^

ALTER PROCEDURE LISTA_ADRESOW (P_IDOS Integer)
returns (OPIS      Char(50),
         ADRES     Char(110),
         ID_ADRESU Integer)
AS 
 BEGIN EXIT; END^

ALTER PROCEDURE LISTA_OSOB_FIZ (ST_NAZWA  Varchar(35),
       ST_IMIE   Varchar(25),
       ST_MIASTO Varchar(30),
       ST_ULICA  Varchar(40),
       ST_PESEL  Varchar(11))
returns (NAZWA     Char(60),
         ADRES     Char(110),
         ID_OSOBY  Integer,
         ID_ADRESU Integer)
AS 
 BEGIN EXIT; END^

ALTER PROCEDURE LISTA_OSOB_PRAW (ST_SNAZWA Varchar(30),
       ST_NAZWA  Varchar(25),
       ST_MIASTO Varchar(30),
       ST_ULICA  Varchar(40),
       ST_REGON  Varchar(20))
returns (NAZWA     Char(120),
         ADRES     Char(110),
         ID_OSOBY  Integer,
         ID_ADRESU Integer,
         ID_KATEG  Integer)
AS 
 BEGIN EXIT; END^

ALTER PROCEDURE LISTA_WGNIP (ST_NIP Varchar(13))
returns (NAZWA     Char(120),
         ADRES     Char(110),
         ID_OSOBY  Integer,
         ID_ADRESU Integer)
AS 
 BEGIN EXIT; END^

ALTER PROCEDURE LN_APPLY_VALUE (IDSYSTEMU   Integer,
       ROK         Integer,
       KODLICZNIKA Varchar(2),
       WARTOSC     Integer)
returns (KODBLEDU Integer)
AS 
 BEGIN EXIT; END^

ALTER PROCEDURE LN_CANCEL_VALUE (IDSYSTEMU   Integer,
       ROK         Integer,
       KODLICZNIKA Varchar(2),
       WARTOSC     Integer)
returns (KODBLEDU Integer)
AS 
 BEGIN EXIT; END^

ALTER PROCEDURE LN_CHECK_CODE (IDSYSTEMU   Integer,
       ROK         Integer,
       KODLICZNIKA Varchar(2))
returns (KODBLEDU Integer)
AS 
 BEGIN EXIT; END^

ALTER PROCEDURE LN_CLEAR_STACK (IDSYSTEMU   Integer,
       ROK         Integer,
       KODLICZNIKA Varchar(2))
returns (KODBLEDU Integer)
AS 
 BEGIN EXIT; END^

ALTER PROCEDURE LN_GET_VALUE (IDSYSTEMU   Integer,
       ROK         Integer,
       KODLICZNIKA Varchar(2))
returns (WARTOSC Integer)
AS 
 BEGIN EXIT; END^

ALTER PROCEDURE LN_SET_TO (IDSYSTEMU   Integer,
       ROK         Integer,
       KODLICZNIKA Varchar(2),
       WARTOSC     Integer)
returns (KODBLEDU Integer)
AS 
 BEGIN EXIT; END^

ALTER PROCEDURE OP_ALLOPER 
returns (KOD_OPER   Smallint,
         NAZWA      Varchar(20),
         HASLO      Varchar(30),
         OPIS       Varchar(100),
         NAZWA_ZEWN Varchar(50),
         STATUS     Char(1))
AS 
 BEGIN EXIT; END^

ALTER PROCEDURE OP_ALLRIGHTS (ID_SYSTEMU Integer,
       ID_OPER    Integer)
returns (KOD_FUN Char(5))
AS 
 BEGIN EXIT; END^

ALTER PROCEDURE OP_HASRIGHTS (ID_SYSTEMU Integer,
       ID_OPER    Integer,
       FUN        Varchar(5))
returns (RESULT Char(1))
AS 
 BEGIN EXIT; END^

ALTER PROCEDURE OS_STATS 
returns (TOT_OS  Integer,
         TOT_OR  Integer,
         TOT_ROZ Integer,
         TOT_BOF Integer,
         TOT_BOP Integer)
AS 
 BEGIN EXIT; END^

ALTER PROCEDURE BO_NEWIDADR 
returns (NOWYNUMER Integer)
AS 
 BEGIN EXIT; END^
ALTER PROCEDURE BO_NEWIDKAT 
returns (NOWYNUMER Integer)
AS 
 BEGIN EXIT; END^
ALTER PROCEDURE BO_NEWIDOSOB 
returns (NOWYNUMER Integer)
AS 
 BEGIN EXIT; END^
ALTER PROCEDURE OP_HASRIGHTS (ID_SYSTEMU Integer,
       ID_OPER    Integer,
       FUN        Varchar(5))
returns (RESULT Char(1))
AS 
 BEGIN EXIT; END^
ALTER PROCEDURE OS_LASTDAY 
returns (LP         Integer,
         DATA       Date,
         NAZWA      Char(80),
         ADRES      Char(80),
         KWOTA      Numeric(15,2),
         ODSETKI    Numeric(15,2),
         ID_OSOBY   Integer,
         ID_ADRESU  Integer,
         DOKUMENT   Char(1),
         NUMERDOK   Varchar(20),
         ID_OPLATY  Integer,
         ZWROT      Smallint,
         OPIS       Varchar(80),
         ID_ROZL    Integer,
         OPERATOR   Varchar(10),
         NAZ_OPLATY Varchar(80),
         PODSTAWA   Numeric(15,2),
         STAWKA     Numeric(15,2),
         NAL_STAWKA Numeric(15,2),
         DATA_DOK   Date,
         NUMER_GEN  Integer)
AS 
 BEGIN EXIT; END^
ALTER PROCEDURE OS_NEWIDSLOS 
returns (NOWYNUMER Integer)
AS 
 BEGIN EXIT; END^
ALTER PROCEDURE OS_NEWOS 
returns (NOWYNUMER Integer)
AS 
 BEGIN EXIT; END^
ALTER PROCEDURE OS_NEWRZL 
returns (NOWYNUMER Integer)
AS 
 BEGIN EXIT; END^
ALTER PROCEDURE OS_NEWUNO 
returns (NOWYNUMER Integer)
AS 
 BEGIN EXIT; END^
ALTER PROCEDURE OS_STATS 
returns (TOT_OS  Integer,
         TOT_OR  Integer,
         TOT_ROZ Integer,
         TOT_BOF Integer,
         TOT_BOP Integer)
AS 
 BEGIN EXIT; END^

CREATE OR ALTER PROCEDURE BO_ADRTOSTR (MIEJSC    Varchar(56),
       ULICA     Varchar(65),
       DOM       Varchar(20),
       LOKAL     Varchar(10),
       KOD       Varchar(6),
       POCZTA    Varchar(56),
       TYP_ULICY Varchar(10))
returns (ADRES Varchar(180))
AS 
 BEGIN EXIT; END^

CREATE OR ALTER PROCEDURE BO_ADRTOSTRSEL (MIEJSC    Varchar(56),
       ULICA     Varchar(65),
       DOM       Varchar(20),
       LOKAL     Varchar(10),
       KOD       Varchar(6),
       POCZTA    Varchar(56),
       TYP_ULICY Varchar(10))
returns (ADRES Varchar(180))
AS 
 BEGIN EXIT; END^

CREATE OR ALTER PROCEDURE BO_LISTA_OSOB (PNAZWA Varchar(50))
returns (NAZWA     Varchar(120),
         ADRES     Varchar(180),
         ID_OSOBY  Integer,
         ID_ADRESU Integer)
AS 
 BEGIN EXIT; END^

CREATE OR ALTER PROCEDURE BO_READOSB (P_IDOS  Integer,
       P_IDADR Integer)
returns (NAZWA Varchar(120),
         ADRES Varchar(180),
         PESEL Varchar(11),
         NIP   Varchar(13),
         REGON Varchar(15),
         PKD   Varchar(10),
         EKD   Varchar(10))
AS 
 BEGIN EXIT; END^

CREATE OR ALTER PROCEDURE BO_SP_ADR_GEN_ID 
returns (ID_ADRESU Integer)
AS 
 BEGIN EXIT; END^

CREATE OR ALTER PROCEDURE BO_SP_KTG_GEN_ID 
returns (ID_KATEG Integer)
AS 
 BEGIN EXIT; END^

CREATE OR ALTER PROCEDURE BO_SP_MN_GEN_ID 
returns (ID_OSOBY Integer)
AS 
 BEGIN EXIT; END^

SET TERM ; ^
ALTER TABLE BO_ADRES DROP CONSTRAINT INTEG_7;

ALTER TABLE BO_FIZ DROP CONSTRAINT INTEG_12;
ALTER TABLE BO_FIZ DROP CONSTRAINT INTEG_14;

ALTER TABLE BO_MAIN DROP CONSTRAINT INTEG_1;
ALTER TABLE BO_MAIN DROP CONSTRAINT INTEG_2;

ALTER TABLE BO_PRAWNE DROP CONSTRAINT INTEG_19;

DROP VIEW OSOBY_FIZYCZNE;

DROP PROCEDURE BO_NEWIDADR;
DROP PROCEDURE BO_NEWIDKAT;
DROP PROCEDURE BO_NEWIDOSOB;
DROP PROCEDURE OP_HASRIGHTS;


ALTER TABLE BO_ADRKOR DROP CONSTRAINT ADRKOR_TO_ADRES;

ALTER TABLE BO_PRAWNE DROP CONSTRAINT PRAWNE_TO_SLKAT;

DROP INDEX IND_ADRES;

DROP INDEX IND_BONAZIM;

DROP INDEX IND_BONAZWA;
DROP INDEX IND_BOREGON;

ALTER TABLE BO_PRAWNE DROP CONSTRAINT INTEG_17;

DROP EXCEPTION LN_EXC_NO_VALUE;
CREATE EXCEPTION LN_EXC_NO_VALUE 'Warto licznika nie zostaa pobrana';



ALTER TABLE BO_ADRES ADD TEMP$$LCHG_VALUE Varchar(95);
UPDATE BO_ADRES SET TEMP$$LCHG_VALUE = LCHG_VALUE;
ALTER TABLE BO_ADRES DROP LCHG_VALUE;
ALTER TABLE BO_ADRES ALTER COLUMN TEMP$$LCHG_VALUE TO LCHG_VALUE;

ALTER TABLE BO_FIZ ADD TEMP$$LCHG_VALUE Varchar(90);
UPDATE BO_FIZ SET TEMP$$LCHG_VALUE = LCHG_VALUE;
ALTER TABLE BO_FIZ DROP LCHG_VALUE;
ALTER TABLE BO_FIZ ALTER COLUMN TEMP$$LCHG_VALUE TO LCHG_VALUE;

ALTER TABLE BO_FIZ ADD TEMP$$IMIE_DRUGIE Varchar(25) COLLATE PXW_PLK;
UPDATE BO_FIZ SET TEMP$$IMIE_DRUGIE = IMIE_DRUGIE;
ALTER TABLE BO_FIZ DROP IMIE_DRUGIE;
ALTER TABLE BO_FIZ ALTER COLUMN TEMP$$IMIE_DRUGIE TO IMIE_DRUGIE;

ALTER TABLE BO_FIZ ADD TEMP$$IMIE_MATKI Varchar(25) COLLATE PXW_PLK;
UPDATE BO_FIZ SET TEMP$$IMIE_MATKI = IMIE_MATKI;
ALTER TABLE BO_FIZ DROP IMIE_MATKI;
ALTER TABLE BO_FIZ ALTER COLUMN TEMP$$IMIE_MATKI TO IMIE_MATKI;

ALTER TABLE BO_FIZ ADD TEMP$$IMIE_OJCA Varchar(25) COLLATE PXW_PLK;
UPDATE BO_FIZ SET TEMP$$IMIE_OJCA = IMIE_OJCA;
ALTER TABLE BO_FIZ DROP IMIE_OJCA;
ALTER TABLE BO_FIZ ALTER COLUMN TEMP$$IMIE_OJCA TO IMIE_OJCA;

ALTER TABLE BO_PRAWNE ADD TEMP$$PKD Varchar(10);
UPDATE BO_PRAWNE SET TEMP$$PKD = PKD;
ALTER TABLE BO_PRAWNE DROP PKD;
ALTER TABLE BO_PRAWNE ALTER COLUMN TEMP$$PKD TO PKD;

ALTER TABLE BO_PRAWNE ADD TEMP$$EKD Varchar(10);
UPDATE BO_PRAWNE SET TEMP$$EKD = EKD;
ALTER TABLE BO_PRAWNE DROP EKD;
ALTER TABLE BO_PRAWNE ALTER COLUMN TEMP$$EKD TO EKD;

ALTER TABLE BO_PRAWNE ADD TEMP$$WWW Varchar(40);
UPDATE BO_PRAWNE SET TEMP$$WWW = WWW;
ALTER TABLE BO_PRAWNE DROP WWW;
ALTER TABLE BO_PRAWNE ALTER COLUMN TEMP$$WWW TO WWW;

ALTER TABLE BO_PRAWNE ADD TEMP$$NAZWA_SKR Varchar(50) NOT NULL COLLATE PXW_PLK;
UPDATE BO_PRAWNE SET TEMP$$NAZWA_SKR = NAZWA_SKR;
ALTER TABLE BO_PRAWNE DROP NAZWA_SKR;
ALTER TABLE BO_PRAWNE ALTER COLUMN TEMP$$NAZWA_SKR TO NAZWA_SKR;

ALTER TABLE BO_PRAWNE ADD TEMP$$NAZWA Varchar(180) NOT NULL COLLATE PXW_PLK;
UPDATE BO_PRAWNE SET TEMP$$NAZWA = NAZWA;
ALTER TABLE BO_PRAWNE DROP NAZWA;
ALTER TABLE BO_PRAWNE ALTER COLUMN TEMP$$NAZWA TO NAZWA;

ALTER TABLE BO_PRAWNE ADD TEMP$$LCHG_VALUE Varchar(230) COLLATE PXW_PLK;
UPDATE BO_PRAWNE SET TEMP$$LCHG_VALUE = LCHG_VALUE;
ALTER TABLE BO_PRAWNE DROP LCHG_VALUE;
ALTER TABLE BO_PRAWNE ALTER COLUMN TEMP$$LCHG_VALUE TO LCHG_VALUE;

ALTER TABLE IS_REJESTR ADD TEMP$$NAZWA Varchar(12);
UPDATE IS_REJESTR SET TEMP$$NAZWA = NAZWA;
ALTER TABLE IS_REJESTR DROP NAZWA;
ALTER TABLE IS_REJESTR ALTER COLUMN TEMP$$NAZWA TO NAZWA;

ALTER TABLE IS_REJESTR ADD TEMP$$OPIS Varchar(100);
UPDATE IS_REJESTR SET TEMP$$OPIS = OPIS;
ALTER TABLE IS_REJESTR DROP OPIS;
ALTER TABLE IS_REJESTR ALTER COLUMN TEMP$$OPIS TO OPIS;

ALTER TABLE IS_REJESTR ADD TEMP$$PATH Varchar(100);
UPDATE IS_REJESTR SET TEMP$$PATH = PATH;
ALTER TABLE IS_REJESTR DROP PATH;
ALTER TABLE IS_REJESTR ALTER COLUMN TEMP$$PATH TO PATH;

ALTER TABLE IS_REJESTR ADD TEMP$$PARAMS Varchar(100);
UPDATE IS_REJESTR SET TEMP$$PARAMS = PARAMS;
ALTER TABLE IS_REJESTR DROP PARAMS;
ALTER TABLE IS_REJESTR ALTER COLUMN TEMP$$PARAMS TO PARAMS;

ALTER TABLE IS_REJESTR ADD TEMP$$ACT_KEY Varchar(30);
UPDATE IS_REJESTR SET TEMP$$ACT_KEY = ACT_KEY;
ALTER TABLE IS_REJESTR DROP ACT_KEY;
ALTER TABLE IS_REJESTR ALTER COLUMN TEMP$$ACT_KEY TO ACT_KEY;

ALTER TABLE LZ_LOG ADD TEMP$$OPIS Varchar(300) COLLATE PXW_PLK;
UPDATE LZ_LOG SET TEMP$$OPIS = OPIS;
ALTER TABLE LZ_LOG DROP OPIS;
ALTER TABLE LZ_LOG ALTER COLUMN TEMP$$OPIS TO OPIS;

ALTER TABLE OP_GRUPY ADD TEMP$$NAZWA Char(15);
UPDATE OP_GRUPY SET TEMP$$NAZWA = NAZWA;
ALTER TABLE OP_GRUPY DROP NAZWA;
ALTER TABLE OP_GRUPY ALTER COLUMN TEMP$$NAZWA TO NAZWA;

ALTER TABLE OP_GRUPY ADD TEMP$$OPIS Char(100);
UPDATE OP_GRUPY SET TEMP$$OPIS = OPIS;
ALTER TABLE OP_GRUPY DROP OPIS;
ALTER TABLE OP_GRUPY ALTER COLUMN TEMP$$OPIS TO OPIS;

ALTER TABLE OP_OPER ADD TEMP$$NAZWA DOM_NAZ_OPER;
UPDATE OP_OPER SET TEMP$$NAZWA = NAZWA;
ALTER TABLE OP_OPER DROP NAZWA;
ALTER TABLE OP_OPER ALTER COLUMN TEMP$$NAZWA TO NAZWA;

ALTER TABLE OP_OPER ADD TEMP$$OPIS Varchar(100);
UPDATE OP_OPER SET TEMP$$OPIS = OPIS;
ALTER TABLE OP_OPER DROP OPIS;
ALTER TABLE OP_OPER ALTER COLUMN TEMP$$OPIS TO OPIS;

ALTER TABLE OP_OPER ADD TEMP$$NAZWA_ZEWN Varchar(50);
UPDATE OP_OPER SET TEMP$$NAZWA_ZEWN = NAZWA_ZEWN;
ALTER TABLE OP_OPER DROP NAZWA_ZEWN;
ALTER TABLE OP_OPER ALTER COLUMN TEMP$$NAZWA_ZEWN TO NAZWA_ZEWN;

ALTER TABLE OP_SLFUN ADD TEMP$$OPIS Char(100);
UPDATE OP_SLFUN SET TEMP$$OPIS = OPIS;
ALTER TABLE OP_SLFUN DROP OPIS;
ALTER TABLE OP_SLFUN ALTER COLUMN TEMP$$OPIS TO OPIS;

ALTER TABLE BO_ADRES ADD KRAJ Varchar(30) COLLATE PXW_PLK;
ALTER TABLE BO_ADRES ADD WOJEWODZTWO Varchar(30) COLLATE PXW_PLK;
ALTER TABLE BO_ADRES ADD POWIAT Varchar(30) COLLATE PXW_PLK;
ALTER TABLE BO_ADRES ADD GMINA Varchar(30) COLLATE PXW_PLK;
ALTER TABLE BO_ADRES ADD DZIELNICA Varchar(30) COLLATE PXW_PLK;
ALTER TABLE BO_ADRES ADD POCZTA Varchar(30) COLLATE PXW_PLK;
ALTER TABLE BO_ADRES ADD TYP_ULICY Varchar(10) COLLATE PXW_PLK;
ALTER TABLE BO_ADRES ADD TYP_ADRESU Char(1);
ALTER TABLE BO_ADRES ADD MIASTO_UP Varchar(56) COLLATE PXW_PLK;
ALTER TABLE BO_ADRES ADD ULICA_UP Varchar(65) COLLATE PXW_PLK;
ALTER TABLE BO_ADRES ADD DOM_UP Varchar(15);
ALTER TABLE BO_ADRES ADD OPER_ADR Integer;

ALTER TABLE BO_FIZ ADD NR_DOWODU Varchar(10);
ALTER TABLE BO_FIZ ADD TYP_DOK Char(1);
ALTER TABLE BO_FIZ ADD MIEJSCE_UR Varchar(30) COLLATE PXW_PLK;
ALTER TABLE BO_FIZ ADD PLEC Char(1);
ALTER TABLE BO_FIZ ADD NZW_RODOWE Varchar(35) COLLATE PXW_PLK;
ALTER TABLE BO_FIZ ADD OBYWATELSTWO Varchar(30) COLLATE PXW_PLK;
ALTER TABLE BO_FIZ ADD NAZWISKO_UP Varchar(40) COLLATE PXW_PLK;
ALTER TABLE BO_FIZ ADD IMIE_UP Varchar(30) COLLATE PXW_PLK;

ALTER TABLE BO_MAIN ADD RODZAJ_OSB Char(1);
ALTER TABLE BO_MAIN ADD NAZWA Varchar(80) NOT NULL COLLATE PXW_PLK;
ALTER TABLE BO_MAIN ADD REJ_DATA Date;
ALTER TABLE BO_MAIN ADD REJ_OPERATOR DOM_NAZ_OPER DEFAULT USER;
ALTER TABLE BO_MAIN ADD TELEFON Varchar(20);
ALTER TABLE BO_MAIN ADD DATA_UDP Date;
ALTER TABLE BO_MAIN ADD KOD_KRAJU Char(2);
ALTER TABLE BO_MAIN ADD PKD Varchar(10);
ALTER TABLE BO_MAIN ADD US Varchar(80) COLLATE PXW_PLK;
ALTER TABLE BO_MAIN ADD REGON Varchar(15);
ALTER TABLE BO_MAIN ADD RB_LK Varchar(2);
ALTER TABLE BO_MAIN ADD RB_NUMER Varchar(40);
ALTER TABLE BO_MAIN ADD NAZWA_UP Varchar(80) COLLATE PXW_PLK;
ALTER TABLE BO_MAIN ADD OPER_OSB Integer;

ALTER TABLE BO_PRAWNE ADD NUMER_KRS Varchar(10);
ALTER TABLE BO_PRAWNE ADD NAZWA_SADU Varchar(60) COLLATE PXW_PLK;
ALTER TABLE BO_PRAWNE ADD NAZWA_PLN_UP Varchar(80) COLLATE PXW_PLK;
ALTER TABLE BO_PRAWNE ADD NAZWA_SKR_UP Varchar(50) COLLATE PXW_PLK;

ALTER TABLE IS_REJESTR ADD ROK Integer;
ALTER TABLE IS_REJESTR ADD KONTO Varchar(12);

CREATE TABLE BO_DBF2SQL (
       PESEL Char(11) NOT NULL,
       ID_SYSTEMU Integer NOT NULL,
       GRUPA Integer NOT NULL,
       ID_OSOBY Integer NOT NULL,
       ID_ADRESU Integer NOT NULL,
       CONSTRAINT BO_PK_DBF2SQL PRIMARY KEY (PESEL,ID_SYSTEMU,GRUPA)
);



CREATE TABLE BO_MALZ (
       ID_OSOBY DOM_ID_OSOB /*Integer NOT NULL*/ NOT NULL,
       ID_OSOBY_X DOM_ID_OSOB /*Integer NOT NULL*/,
       ID_OSOBY_Y DOM_ID_OSOB /*Integer NOT NULL*/,
       NAZWA Varchar(80) NOT NULL COLLATE PXW_PLK,
       LCHG_DATA Date,
       LCHG_OPERATOR DOM_NAZ_OPER /*Varchar(20) NOT NULL*/ DEFAULT USER,
       LCHG_VALUE Varchar(80),
       NAZWA_MLZ_UP Varchar(80) COLLATE PXW_PLK,
       CONSTRAINT PK_BO_MALZ PRIMARY KEY (ID_OSOBY)
);



CREATE TABLE BO_UDOSTP (
       ID_OSOBY DOM_ID_OSOB /*Integer NOT NULL*/ NOT NULL,
       ID_UDOSTP Integer NOT NULL,
       NAZWA_ODB Varchar(80) COLLATE PXW_PLK,
       DATA Date,
       ZAKRES Varchar(60) COLLATE PXW_PLK,
       PRZEZNACZENIE Varchar(60) COLLATE PXW_PLK,
       CONSTRAINT BO_PK_UDOSTP PRIMARY KEY (ID_OSOBY,ID_UDOSTP)
);



CREATE TABLE BO_UPOW (
       ID_UPOW Varchar(20) NOT NULL,
       DATA_WYD Date,
       DATA_POCZ Date,
       DATA_KON Date,
       ZAKRES Varchar(80) COLLATE PXW_PLK,
       KOD_OPER Integer NOT NULL,
       CONSTRAINT BO_PK_UPOW PRIMARY KEY (ID_UPOW)
);



INSERT INTO BO_ADRES (KOD,MIASTO,ULICA,DOM,LOKAL,ID_ADRESU) 
SELECT KOD,MIASTO,ULICA,DOM,LOKAL,ID_ADRESU FROM BO_ADRKOR;



DROP TABLE BO_ADRKOR;
DROP TABLE OP_ORGAN;

update BO_MAIN set REGON = (SELECT BO_PRAWNE.REGON FROM BO_PRAWNE WHERE BO_PRAWNE.ID_OSOBY = BO_MAIN.ID_OSOBY),NAZWA='';
update BO_MAIN set RODZAJ_OSB = 'F', NAZWA= '' WHERE OS_FIZYCZNA = 'T';
update BO_MAIN set RODZAJ_OSB = 'P', NAZWA= '' WHERE OS_FIZYCZNA = 'N';

UPDATE BO_PRAWNE SET ID_KATEG= NULL;
ALTER TABLE BO_PRAWNE DROP REGON;

CREATE INDEX BO_IDX_ADR_MIASTO ON BO_ADRES(MIASTO_UP);
CREATE INDEX BO_IDX_ADR_ULICA ON BO_ADRES(ULICA_UP);

CREATE INDEX BO_IDX_FIZ_IMIE ON BO_FIZ(IMIE_UP);
CREATE INDEX BO_IDX_FIZ_NAZWISKO ON BO_FIZ(NAZWISKO_UP);
CREATE INDEX BO_IDX_FIZ_NRDOW ON BO_FIZ(NR_DOWODU);

CREATE INDEX BO_IDX_MN_NAZWA ON BO_MAIN(NAZWA_UP);
CREATE INDEX BO_IDX_MN_REGON ON BO_MAIN(REGON);

CREATE INDEX BO_IDX_PRW_NAZWA ON BO_PRAWNE(NAZWA_PLN_UP);
CREATE INDEX BO_IDX_PRW_SKROT ON BO_PRAWNE(NAZWA_SKR_UP);

ALTER TABLE BO_ADRES ADD CONSTRAINT BO_REL_OPR2ADR FOREIGN KEY (OPER_ADR) REFERENCES OP_OPER(KOD_OPER) ON UPDATE CASCADE;

ALTER TABLE BO_DBF2SQL ADD CONSTRAINT BO_REL_D2S2ADR FOREIGN KEY (ID_ADRESU) REFERENCES BO_ADRES(ID_ADRESU) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE BO_DBF2SQL ADD CONSTRAINT BO_REL_D2S2MN FOREIGN KEY (ID_OSOBY) REFERENCES BO_MAIN(ID_OSOBY) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE BO_MAIN ADD CONSTRAINT BO_REL_OPR2MN FOREIGN KEY (OPER_OSB) REFERENCES OP_OPER(KOD_OPER) ON UPDATE CASCADE;

ALTER TABLE BO_MALZ ADD CONSTRAINT BO_REL_MN2MLZ FOREIGN KEY (ID_OSOBY) REFERENCES BO_MAIN(ID_OSOBY) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE BO_PRAWNE ADD CONSTRAINT BO_REL_KTG2PRW FOREIGN KEY (ID_KATEG) REFERENCES BO_SLKAT(ID_KATEG) ON UPDATE CASCADE;

ALTER TABLE BO_UDOSTP ADD CONSTRAINT BO_REL_MN2UDP FOREIGN KEY (ID_OSOBY) REFERENCES BO_MAIN(ID_OSOBY) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE BO_UPOW ADD CONSTRAINT BO_REL_OPR2UDP FOREIGN KEY (KOD_OPER) REFERENCES OP_OPER(KOD_OPER) ON UPDATE CASCADE;

ALTER TABLE LZ_LOG ADD CONSTRAINT LZ_REL_OPE2ZMI FOREIGN KEY (ID_SYSTEMU,KOD_OPERACJI) REFERENCES LZ_OPERACJE(ID_SYSTEMU,KOD_OPERACJI) ON UPDATE CASCADE;

ALTER TABLE LZ_OPERACJE ADD CONSTRAINT LZ_REL_REJ2OPE FOREIGN KEY (ID_SYSTEMU) REFERENCES IS_REJESTR(ID_SYSTEMU) ON UPDATE CASCADE;

CREATE VIEW OSOBY_FIZYCZNE(ID_OSOBY,NAZWISKO,IMIE,MIASTO,ULICA,DOM,LOKAL)
AS
SELECT BF.ID_OSOBY, BF.NAZWISKO, BF.IMIE, BA.MIASTO, BA.ULICA, BA.DOM, BA.LOKAL FROM BO_FIZ BF
LEFT OUTER JOIN BO_ADRES BA ON (BA.ID_OSOBY = BF.ID_OSOBY)
;

ALTER TABLE BO_ADRES ADD CONSTRAINT BO_CST_ADR_TYP_ADRESU CHECK ( TYP_ADRESU IN ('M','K','Z','S','T','I') );
ALTER TABLE BO_ADRES ADD CONSTRAINT BO_CST_ADR_MIASTO CHECK ( MIASTO <> '' );

ALTER TABLE BO_FIZ ADD CONSTRAINT BO_CST_FIZ_NAZWISKO CHECK ( NAZWISKO <> '' );
ALTER TABLE BO_FIZ ADD CONSTRAINT BO_CST_FIZ_IMIE CHECK (  IMIE <> '' );
ALTER TABLE BO_FIZ ADD CONSTRAINT BO_CST_FIZ_PLEC CHECK ( PLEC IS NULL OR PLEC IN ('M', 'K') );
ALTER TABLE BO_FIZ ADD CONSTRAINT BO_CST_FIZ_TYPDOK CHECK ( TYP_DOK IS NULL OR TYP_DOK IN ('P', 'D', 'R') );

ALTER TABLE BO_MAIN ADD CONSTRAINT BO_CST_MN_RODZAJ_OSB CHECK ( RODZAJ_OSB IN ('F', 'P', 'M') );
ALTER TABLE BO_MAIN ADD CONSTRAINT BO_CST_MN_NAZWA CHECK ( NAZWA <> '' );
ALTER TABLE BO_MAIN ADD CONSTRAINT BO_CST_MN_CHG_KOD CHECK ( CHG_KOD IN ('W', 'E', 'X') );

ALTER TABLE BO_MALZ ADD CONSTRAINT BO_CST_MLZ_NAZWA CHECK ( NAZWA <> '' );

ALTER TABLE BO_PRAWNE ADD CONSTRAINT BO_CST_PRW_NAZWA CHECK ( NAZWA <> '' );

ALTER TABLE BO_SLKAT ADD CONSTRAINT BO_CST_KAT_NAZWA CHECK ( NAZWA <> '' );

SET TERM ^ ;
ALTER PROCEDURE BO_ADRTOSTR (MIEJSC    Varchar(56),
       ULICA     Varchar(65),
       DOM       Varchar(20),
       LOKAL     Varchar(10),
       KOD       Varchar(6),
       POCZTA    Varchar(56),
       TYP_ULICY Varchar(10))
returns (ADRES Varchar(180))
AS 
  declare variable ADR_PREFIX VARCHAR(60);
  declare variable TMP_POCZTA VARCHAR(56);
begin
 IF (MIEJSC IS NULL) THEN MIEJSC = '';
 IF (ULICA IS NULL) THEN ULICA = '';
 IF (DOM IS NULL) THEN DOM = '';
 IF (LOKAL IS NULL) THEN LOKAL = '';
 IF (KOD IS NULL) THEN KOD = '';
 IF (POCZTA IS NULL) THEN POCZTA = '';
 IF (TYP_ULICY IS NULL) THEN TYP_ULICY = '';
 /* Nazwa miejscowoci na pocztku adresu dodawana jest tylko wtedy, gdy spenione s */
 /* nastpujce warunki: */
 /* 1) nazwa miejscowoci jest okrelona, */
 /* 2) nazwa ulicy jest okrelona i jest rna od nazwy miejscowoci, */
 /* 3) nazwa poczty jest okrelona i jest rna od nazwy miejsowoci. */
 /* Jeeli punkt 2) nie jest speniony, to nazwa miejscowoci umieszczana jest w miejsce nazwy */
 /* ulicy. Jeeli nie jest speniony punkt 3, to nazwa miejscowoci umieszczana jest w nazwie */
 /* poczty niezalenie od tego, czy kod pocztowy zosta okrelony. */
 IF (MIEJSC <> '' AND ULICA <> '' AND UPPER(MIEJSC) <> UPPER(ULICA) AND POCZTA <> '' AND UPPER(POCZTA) <> UPPER(MIEJSC)) THEN
 ADR_PREFIX = MIEJSC;
 ELSE
 ADR_PREFIX = '';
 /* Jeeli ulica jest pusta, to przed numerem domu umieszczana jest nazwa miejscowoci */
 IF (ULICA = '') THEN
 ADRES = MIEJSC;
 ELSE
 BEGIN
 /* typ ulicy uwzgldniany jest tylko wtedy, gdy okrelona jest nazwa ulicy */
 IF (TYP_ULICY <> '') THEN
 ADRES = TYP_ULICY || ' ' || ULICA;
 ELSE
 ADRES = ULICA;
 END
 /* Numer domu */
 IF (DOM <> '') THEN
 BEGIN
 IF (ADRES <> '') THEN
 ADRES = ADRES || ' ';
 ADRES = ADRES || DOM;
 END
 /* Numer lokalu */
 IF (LOKAL <> '') THEN
 BEGIN
 IF (ADRES <> '') THEN
 ADRES = ADRES || ' ';
 ADRES = ADRES || 'm.' || LOKAL;
 END
 /* Kod pocztowy i nazwa poczty */
 IF (KOD <> '') THEN
 BEGIN
 IF (ADRES <> '') THEN
 ADRES = ADRES || ', ';
 ADRES = ADRES || KOD;
 IF (POCZTA <> '') THEN
 TMP_POCZTA = POCZTA;
 ELSE
 TMP_POCZTA = MIEJSC;
 IF (TMP_POCZTA <> '') THEN
 ADRES = ADRES || ' ' || TMP_POCZTA;
 END
 ELSE
 BEGIN
 IF (POCZTA <> '') THEN
 TMP_POCZTA = POCZTA;
 ELSE
 TMP_POCZTA = MIEJSC;
 IF (TMP_POCZTA <> '' AND UPPER(TMP_POCZTA) <> UPPER(ADRES) AND
 ((ULICA <> '' AND UPPER(ULICA) <> UPPER(TMP_POCZTA)) OR
 (ULICA = '' AND UPPER(MIEJSC) <> UPPER(POCZTA)))) THEN
 BEGIN
 IF (ADRES <> '') THEN
 ADRES = ADRES || ', ';
 ADRES = ADRES || TMP_POCZTA;
 END
 END
 IF (ADR_PREFIX <> '') THEN
 BEGIN
 IF (ADRES <> '') THEN
 ADR_PREFIX = ADR_PREFIX || ', ';
 ADRES = ADR_PREFIX || ADRES;
 END
end^

ALTER PROCEDURE BO_ADRTOSTRSEL (MIEJSC    Varchar(56),
       ULICA     Varchar(65),
       DOM       Varchar(20),
       LOKAL     Varchar(10),
       KOD       Varchar(6),
       POCZTA    Varchar(56),
       TYP_ULICY Varchar(10))
returns (ADRES Varchar(180))
AS 

begin
 EXECUTE PROCEDURE BO_ADRTOSTR(MIEJSC,ULICA,DOM,LOKAL,KOD,POCZTA,TYP_ULICY) RETURNING_VALUES :ADRES;
 SUSPEND;
end^

ALTER PROCEDURE BO_ATTACH (ID_SYSTEMU Smallint,
       ID_OSOBY   Integer,
       ID_ADRESU  Integer)
AS 
  declare variable CNT INTEGER;
begin
 SELECT COUNT(*) FROM BO_FLAGI
 WHERE BO_FLAGI.ID_OSOBY    = :id_osoby   AND
 BO_FLAGI.ID_ADRESU   = :id_adresu  AND
 BO_FLAGI.KOD_SYSTEMU = :id_systemu
 INTO :CNT;
 IF (CNT IS NULL OR CNT = 0) THEN
 INSERT INTO BO_FLAGI(KOD_SYSTEMU, ID_OSOBY, ID_ADRESU, LICZNIK)
 VALUES(:id_systemu, :id_osoby, :id_adresu, 1);
 ELSE
 UPDATE BO_FLAGI
 SET LICZNIK = LICZNIK + 1
 WHERE BO_FLAGI.ID_OSOBY    = :id_osoby   AND
 BO_FLAGI.ID_ADRESU   = :id_adresu  AND
 BO_FLAGI.KOD_SYSTEMU = :id_systemu;
end^

ALTER PROCEDURE BO_DELETE (ID_OSOBY  Integer,
       ID_ADRESU Integer)
AS 

begin
 /* Usunicie danych adresowych */
 DELETE FROM BO_ADRES WHERE ID_ADRESU = :ID_ADRESU;
 /* Usunicie danych osobowych */
 DELETE FROM BO_MAIN WHERE ID_OSOBY = :ID_OSOBY;
end^

ALTER PROCEDURE BO_DETACH (ID_SYSTEMU Smallint,
       ID_OSOBY   Integer,
       ID_ADRESU  Integer)
AS 
  declare variable CNT INTEGER;
begin
 SELECT LICZNIK FROM BO_FLAGI
 WHERE BO_FLAGI.ID_OSOBY    = :id_osoby   AND
 BO_FLAGI.ID_ADRESU   = :id_adresu  AND
 BO_FLAGI.KOD_SYSTEMU = :id_systemu
 INTO :CNT;
 IF (CNT = 1) THEN
 DELETE FROM BO_FLAGI
 WHERE BO_FLAGI.ID_OSOBY    = :id_osoby   AND
 BO_FLAGI.ID_ADRESU   = :id_adresu  AND
 BO_FLAGI.KOD_SYSTEMU = :id_systemu;
 ELSE
 UPDATE BO_FLAGI
 SET LICZNIK = LICZNIK - 1
 WHERE BO_FLAGI.ID_OSOBY    = :id_osoby   AND
 BO_FLAGI.ID_ADRESU   = :id_adresu  AND
 BO_FLAGI.KOD_SYSTEMU = :id_systemu;
end^

ALTER PROCEDURE BO_LISTA_OSOB (PNAZWA Varchar(50))
returns (NAZWA     Varchar(120),
         ADRES     Varchar(180),
         ID_OSOBY  Integer,
         ID_ADRESU Integer)
AS 
  declare variable lMiejsc VARCHAR(56);
  declare variable lUl VARCHAR(65);
  declare variable lDom VARCHAR(15);
  declare variable lLokal VARCHAR(10);
  declare variable lKod VARCHAR(6);
  declare variable lPoczta VARCHAR(56);
  declare variable lTypUlicy VARCHAR(10);
begin
 PNAZWA = UPPER(PNAZWA) ||'%';
 FOR
 SELECT BM.NAZWA, BM.ID_OSOBY, BA.ID_ADRESU,
 BA.MIASTO, BA.ULICA, BA.DOM, BA.LOKAL, BA.KOD, BA.POCZTA, BA.TYP_ULICY
 FROM BO_MAIN BM
 LEFT OUTER JOIN BO_ADRES BA ON (BA.ID_OSOBY = BM.ID_OSOBY)
 WHERE BM.NAZWA_UP LIKE :PNAZWA
 INTO :NAZWA, :ID_OSOBY, :ID_ADRESU, :lMiejsc, :lUl, :lDom, :lLokal, :lKod, :lPoczta, :lTypUlicy
 DO
 BEGIN
 /* Utworzenie adresu */
 EXECUTE PROCEDURE BO_ADRTOSTR(lMiejsc,lUl,lDom,lLokal,lKod,lPoczta,lTypUlicy) RETURNING_VALUES :ADRES;
 SUSPEND;
 END
end^

ALTER PROCEDURE BO_READALL (ST_NAZWA  Varchar(80),
       ST_MIASTO Varchar(56),
       ST_ULICA  Varchar(65))
returns (OSFIZ     Char(1),
         NAZWA     Char(120),
         ADRES     Char(180),
         ID_OSOBY  Integer,
         ID_ADRESU Integer,
         ID_KATEG  Integer)
AS 
  declare variable lMiejsc VARCHAR(56);
  declare variable lUl VARCHAR(65);
  declare variable lDom VARCHAR(15);
  declare variable lLokal VARCHAR(10);
  declare variable lKod VARCHAR(6);
  declare variable lPoczta VARCHAR(56);
  declare variable lRodzaj CHAR(1);
  declare variable lTypUlicy VARCHAR(10);
begin
 IF (st_nazwa = '') THEN st_nazwa = '%';
 IF (st_miasto = '') THEN st_miasto = '%';
 IF (st_ulica = '') THEN st_ulica = '%';
 FOR
 SELECT BM.RODZAJ_OSB, BM.NAZWA,
 BA.MIASTO, BA.ULICA, BA.DOM, BA.LOKAL, BA.KOD, BA.POCZTA, BA.TYP_ULICY,
 BM.ID_OSOBY, BA.ID_ADRESU
 FROM BO_MAIN BM
 LEFT OUTER JOIN BO_ADRES BA ON (BM.ID_OSOBY = BA.ID_OSOBY)
 WHERE BM.NAZWA_UP LIKE :st_nazwa AND
 BA.MIASTO_UP LIKE :st_miasto AND
 (BA.ULICA_UP LIKE :st_ulica OR BA.ULICA_UP IS NULL)
 INTO :lRodzaj, :NAZWA, :lMiejsc, :lUl, :lDom, :lLokal, :lKod, :lPoczta, :lTypUlicy, :ID_OSOBY, :ID_ADRESU
 DO
 BEGIN
 /* Odczytanie identyfikatora osoby prawnej */
 IF (lRodzaj = 'P') THEN
 BEGIN
 OSFIZ = 'N';
 SELECT ID_KATEG FROM BO_PRAWNE WHERE ID_OSOBY = :ID_OSOBY
 INTO :ID_KATEG;
 END
 ELSE
 OSFIZ = 'T';
 /* Utworzenie adresu */
 EXECUTE PROCEDURE BO_ADRTOSTR(lMiejsc,lUl,lDom,lLokal,lKod,lPoczta,lTypUlicy) RETURNING_VALUES :ADRES;
 SUSPEND;
 END
end^

ALTER PROCEDURE BO_READFRM (P_IDOS  Integer,
       P_IDADR Integer)
returns (NAZWA Char(120),
         ADRES Char(180))
AS 
  declare variable lMiejsc VARCHAR(56);
  declare variable lUl VARCHAR(65);
  declare variable lDom VARCHAR(15);
  declare variable lLokal VARCHAR(10);
  declare variable lKod VARCHAR(6);
  declare variable lPoczta VARCHAR(56);
  declare variable lTypUlicy VARCHAR(10);
begin
 SELECT BM.NAZWA, BA.MIASTO, BA.ULICA, BA.DOM, BA.LOKAL, BA.KOD, BA.POCZTA, BA.TYP_ULICY FROM BO_MAIN BM
 LEFT OUTER JOIN BO_ADRES BA ON (BA.ID_OSOBY = BM.ID_OSOBY)
 WHERE BM.ID_OSOBY = :p_idos AND BA.ID_ADRESU = :p_idadr
 INTO :NAZWA, :lMiejsc, :lUl, :lDom, :lLokal, :lKod, :lPoczta, :lTypUlicy;
 /* Utworzenie adresu */
 EXECUTE PROCEDURE BO_ADRTOSTR(lMiejsc,lUl,lDom,lLokal,lKod,lPoczta,lTypUlicy) RETURNING_VALUES :ADRES;
 SUSPEND;
end^

ALTER PROCEDURE BO_READOSB (P_IDOS  Integer,
       P_IDADR Integer)
returns (NAZWA Varchar(120),
         ADRES Varchar(180),
         PESEL Varchar(11),
         NIP   Varchar(13),
         REGON Varchar(15),
         PKD   Varchar(10),
         EKD   Varchar(10))
AS 
  declare variable RODZAJ CHAR(1);
  declare variable KOD VARCHAR(6);
  declare variable MIEJSC VARCHAR(56);
  declare variable ULICA VARCHAR(65);
  declare variable DOM VARCHAR(15);
  declare variable LOKAL VARCHAR(10);
  declare variable POCZTA VARCHAR(56);
  declare variable TYPULICY VARCHAR(10);
begin
 /* Odczytanie gwnych danych z adresem */
 SELECT MN.RODZAJ_OSB, MN.NAZWA, MN.NIP, MN.PKD, MN.REGON, AD.ULICA, AD.DOM, AD.LOKAL, AD.KOD, AD.MIASTO, AD.POCZTA, AD.TYP_ULICY FROM BO_MAIN MN
 LEFT OUTER JOIN BO_ADRES AD ON (AD.ID_OSOBY = MN.ID_OSOBY)
 WHERE MN.ID_OSOBY = :P_IDOS AND AD.ID_ADRESU = :P_IDADR
 INTO :RODZAJ, :NAZWA, :NIP, :PKD, :REGON, :ULICA, :DOM, :LOKAL, :KOD, :MIEJSC, :POCZTA, :TYPULICY;
 /* Doczytanie danych szczegowych, zalenych od rodzaju osoby */
 IF (RODZAJ = 'F') THEN
 SELECT PESEL FROM BO_FIZ
 WHERE ID_OSOBY = :P_IDOS
 INTO :PESEL;
 ELSE
 IF (RODZAJ = 'P') THEN
 SELECT EKD FROM BO_PRAWNE
 WHERE ID_OSOBY = :P_IDOS
 INTO :EKD;
 /* Utworzenie adresu */
 EXECUTE PROCEDURE BO_ADRTOSTR(MIEJSC,ULICA,DOM,LOKAL,KOD,POCZTA,TYPULICY) RETURNING_VALUES :ADRES;
 SUSPEND;
end^

ALTER PROCEDURE BO_SP_ADR_GEN_ID 
returns (ID_ADRESU Integer)
AS 

begin
ID_ADRESU = GEN_ID(GEN_ID_ADRESU,1);
end^

ALTER PROCEDURE BO_SP_KTG_GEN_ID 
returns (ID_KATEG Integer)
AS 

begin
ID_KATEG = GEN_ID(GEN_ID_KATEG,1);
end^

ALTER PROCEDURE BO_SP_MN_GEN_ID 
returns (ID_OSOBY Integer)
AS 

begin
ID_OSOBY = GEN_ID(GEN_ID_OSOBY,1);
end^

ALTER PROCEDURE LISTA_ADRESOW (P_IDOS Integer)
returns (OPIS      Char(50),
         ADRES     Char(180),
         ID_ADRESU Integer)
AS 
  declare variable lMiejsc VARCHAR(56);
  declare variable lUl VARCHAR(65);
  declare variable lDom VARCHAR(15);
  declare variable lLokal VARCHAR(10);
  declare variable lKod VARCHAR(6);
  declare variable lPoczta VARCHAR(56);
  declare variable lTypUlicy VARCHAR(10);
begin
 FOR
 SELECT OPIS, MIASTO, ULICA, DOM, LOKAL, KOD, POCZTA, TYP_ULICY, ID_ADRESU FROM BO_ADRES
 WHERE ID_OSOBY = :p_idos
 INTO :OPIS, :lMiejsc, :lUl, :lDom, :lLokal, :lKod, :lPoczta, :lTypUlicy, :ID_ADRESU
 DO
 BEGIN
 /* Utworzenie adresu */
 EXECUTE PROCEDURE BO_ADRTOSTR(lMiejsc,lUl,lDom,lLokal,lKod,lPoczta,lTypUlicy) RETURNING_VALUES :ADRES;
 SUSPEND;
 END
end^

ALTER PROCEDURE LISTA_OSOB_FIZ (ST_NAZWA  Varchar(40),
       ST_IMIE   Varchar(30),
       ST_MIASTO Varchar(56),
       ST_ULICA  Varchar(65),
       ST_PESEL  Varchar(11))
returns (NAZWA     Char(80),
         ADRES     Char(180),
         ID_OSOBY  Integer,
         ID_ADRESU Integer)
AS 
  declare variable lMiejsc VARCHAR(56);
  declare variable lUl VARCHAR(65);
  declare variable lDom VARCHAR(15);
  declare variable lLokal VARCHAR(10);
  declare variable lKod VARCHAR(6);
  declare variable lPoczta VARCHAR(56);
  declare variable lTypUlicy VARCHAR(10);
begin
 IF (st_nazwa = '') THEN st_nazwa = '%';
 IF (st_imie = '') THEN st_imie = '%';
 IF (st_miasto = '') THEN st_miasto = '%';
 IF (st_ulica = '') THEN st_ulica = '%';
 IF (st_pesel = '') THEN st_pesel = '%';
 FOR
 SELECT CAST(BF.NAZWISKO || ' ' || BF.IMIE AS CHAR(80)),
 BA.MIASTO, BA.ULICA, BA.DOM, BA.LOKAL, BA.KOD, BA.POCZTA, BA.TYP_ULICY,
 BF.ID_OSOBY, BA.ID_ADRESU
 FROM BO_FIZ BF
 LEFT OUTER JOIN BO_ADRES BA ON BF.ID_OSOBY = BA.ID_OSOBY
 WHERE BF.NAZWISKO_UP LIKE :st_nazwa AND
 BF.IMIE_UP LIKE :st_imie AND
 (BF.PESEL LIKE :st_pesel OR BF.PESEL IS NULL) AND
 BA.MIASTO_UP LIKE :st_miasto AND
 (BA.ULICA_UP LIKE :st_ulica OR BA.ULICA_UP IS NULL)
 INTO :NAZWA, :lMiejsc, :lUl, :lDom, :lLokal, :lKod, :lPoczta, :lTypUlicy, :ID_OSOBY, :ID_ADRESU
 DO
 BEGIN
 /* Utworzenie adresu */
 EXECUTE PROCEDURE BO_ADRTOSTR(lMiejsc,lUl,lDom,lLokal,lKod,lPoczta,lTypUlicy) RETURNING_VALUES :ADRES;
 SUSPEND;
 END
end^

ALTER PROCEDURE LISTA_OSOB_PRAW (ST_SNAZWA Varchar(40),
       ST_NAZWA  Varchar(30),
       ST_MIASTO Varchar(56),
       ST_ULICA  Varchar(65),
       ST_REGON  Varchar(15))
returns (NAZWA     Char(180),
         ADRES     Char(180),
         ID_OSOBY  Integer,
         ID_ADRESU Integer,
         ID_KATEG  Integer)
AS 
  declare variable lMiejsc VARCHAR(56);
  declare variable lUl VARCHAR(65);
  declare variable lDom VARCHAR(15);
  declare variable lLokal VARCHAR(10);
  declare variable lKod VARCHAR(6);
  declare variable lPoczta VARCHAR(56);
  declare variable lTypUlicy VARCHAR(10);
begin
 IF (st_snazwa = '') THEN st_snazwa = '%';
 IF (st_nazwa = '') THEN st_nazwa = '%';
 IF (st_miasto = '') THEN st_miasto = '%';
 IF (st_ulica = '') THEN st_ulica = '%';
 IF (st_regon = '') THEN st_regon = '%';
 FOR
 SELECT BM.NAZWA,
 BA.MIASTO, BA.ULICA, BA.DOM, BA.LOKAL, BA.KOD, BA.POCZTA, BA.TYP_ULICY,
 BP.ID_KATEG, BP.ID_OSOBY, BA.ID_ADRESU
 FROM BO_PRAWNE BP
 INNER JOIN BO_MAIN BM ON BM.ID_OSOBY = BP.ID_OSOBY
 LEFT OUTER JOIN BO_ADRES BA ON BP.ID_OSOBY = BA.ID_OSOBY
 WHERE BP.NAZWA_SKR_UP LIKE :st_snazwa AND
 BP.NAZWA_PLN_UP LIKE :st_nazwa  AND
 (BM.REGON LIKE :st_regon OR BM.REGON IS NULL) AND
 BA.MIASTO_UP LIKE :st_miasto AND
 (BA.ULICA_UP LIKE :st_ulica OR BA.ULICA IS NULL)
 INTO :NAZWA, :lMiejsc, :lUl, :lDom, :lLokal, :lKod, :lPoczta, :lTypUlicy, :ID_KATEG, :ID_OSOBY, :ID_ADRESU
 DO
 BEGIN
 /* Utworzenie adresu */
 EXECUTE PROCEDURE BO_ADRTOSTR(lMiejsc,lUl,lDom,lLokal,lKod,lPoczta,lTypUlicy) RETURNING_VALUES :ADRES;
 SUSPEND;
 END
end^

ALTER PROCEDURE LISTA_WGNIP (ST_NIP Varchar(13))
returns (NAZWA     Char(120),
         ADRES     Char(180),
         ID_OSOBY  Integer,
         ID_ADRESU Integer)
AS 
  declare variable lMiejsc VARCHAR(56);
  declare variable lUl VARCHAR(65);
  declare variable lDom VARCHAR(15);
  declare variable lLokal VARCHAR(10);
  declare variable lKod VARCHAR(6);
  declare variable lPoczta VARCHAR(56);
  declare variable lTypUlicy VARCHAR(10);
begin
 IF (st_nip = '') THEN
 st_nip = '%';
 FOR
 SELECT BM.NAZWA, BA.MIASTO, BA.ULICA, BA.DOM, BA.LOKAL, BA.KOD, BA.POCZTA, BA.TYP_ULICY,
 BM.ID_OSOBY, BA.ID_ADRESU
 FROM BO_MAIN BM
 LEFT OUTER JOIN BO_ADRES BA ON (BM.ID_OSOBY = BA.ID_OSOBY)
 WHERE BM.NIP LIKE :st_nip
 INTO :NAZWA, :lMiejsc, :lUl, :lDom, :lLokal, :lKod, :lPoczta, :lTypUlicy, :ID_OSOBY, :ID_ADRESU
 DO
 BEGIN
 /* Utworzenie adresu */
 EXECUTE PROCEDURE BO_ADRTOSTR(lMiejsc,lUl,lDom,lLokal,lKod,lPoczta,lTypUlicy) RETURNING_VALUES :ADRES;
 SUSPEND;
 END
end^

ALTER PROCEDURE LN_APPLY_VALUE (IDSYSTEMU   Integer,
       ROK         Integer,
       KODLICZNIKA Varchar(2),
       WARTOSC     Integer)
returns (KODBLEDU Integer)
AS 

begin

      /*
      * sprawdzam, czy podany zosta poprawny kod licznika
      */
      EXECUTE PROCEDURE LN_CHECK_CODE :IdSystemu, :Rok, :KodLicznika RETURNING_VALUES :KodBledu;

      IF (KodBledu = 0) THEN
         EXCEPTION LN_EXC_INVALID_ID;

      /****
      * nastpny SELECT nie nadpisze wartoci zmiennej KodBledu, jeeli
      * nie zostanie znaleziony rekord speniajce podane warunki; std
      * konieczno przypisania zmiennej KodBledu wartoci NULL, aby
      * porwnanie z NULL miao sens
      ****/
      KodBledu = NULL;

      /****
      * jeeli kod bdu jest rwny NULL, to nie zostaa na stosie
      * znaleziona przekazana warto zwizana ze wskazanym licznikiem
      ****/
      SELECT wartosc FROM LN_STOS
      WHERE id_systemu = :IdSystemu AND rok = :Rok AND kod = :KodLicznika AND wartosc = :Wartosc AND stan = 1
      INTO :KodBledu;

      IF (KodBledu IS NULL) THEN BEGIN
         KodBledu = 0;
         EXCEPTION LN_EXC_INVALID_VALUE;
      END

      KodBledu = 0;

      DELETE FROM LN_STOS 
      WHERE id_systemu = :IdSystemu AND rok = :Rok AND kod = :KodLicznika AND wartosc = :Wartosc;

      KodBledu = 1;
end^

ALTER PROCEDURE LN_CANCEL_VALUE (IDSYSTEMU   Integer,
       ROK         Integer,
       KODLICZNIKA Varchar(2),
       WARTOSC     Integer)
returns (KODBLEDU Integer)
AS 

begin

      /****
      * sprawdzam, czy podany zosta poprawny kod licznika
      ****/
      EXECUTE PROCEDURE LN_CHECK_CODE :IdSystemu, :Rok, :KodLicznika RETURNING_VALUES :KodBledu;

      IF (KodBledu = 0) THEN
         EXCEPTION LN_EXC_INVALID_ID;

      /****
      * nastpny SELECT nie nadpisze wartoci zmiennej KodBledu, jeeli
      * nie zostanie znaleziony rekord speniajce podane warunki; std
      * konieczno przypisania zmiennej KodBledu wartoci NULL, aby
      * porwnanie z NULL miao sens
      ****/
      KodBledu = NULL;

      /****
      * jeeli kod bdu jest rwny NULL, to nie zostaa na stosie
      * znaleziona przekazana warto zwizana ze wskazanym licznikiem
      ****/
      SELECT wartosc FROM LN_STOS
      WHERE id_systemu = :IdSystemu AND rok = :Rok AND kod = :KodLicznika AND
            wartosc = :Wartosc AND stan = 1
      INTO :KodBledu;

      IF (KodBledu IS NULL) THEN BEGIN
         KodBledu = 0;
         EXCEPTION LN_EXC_INVALID_VALUE;
      END

      KodBledu = 0;

      UPDATE LN_STOS SET stan = 0
      WHERE id_systemu = :IdSystemu AND rok = :Rok AND kod = :KodLicznika AND
            wartosc = :Wartosc;

      KodBledu = 1;
end^

ALTER PROCEDURE LN_CHECK_CODE (IDSYSTEMU   Integer,
       ROK         Integer,
       KODLICZNIKA Varchar(2))
returns (KODBLEDU Integer)
AS 
  declare variable GlWartosc INTEGER;
begin

      KodBledu = 0;

      SELECT glowny FROM LN_LICZNIKI 
      WHERE id_systemu = :IdSystemu AND rok = :Rok AND kod = :KodLicznika
      INTO :GlWartosc;

      /*
      * jeeli zmienna GlWartosc jest rwna NULL, to przekazany zosta
      * kod nie istniejcego licznika
      */
      IF (GlWartosc IS NOT NULL) THEN
         KodBledu = 1;
end^

ALTER PROCEDURE LN_CLEAR_STACK (IDSYSTEMU   Integer,
       ROK         Integer,
       KODLICZNIKA Varchar(2))
returns (KODBLEDU Integer)
AS 

begin

      /*
      * sprawdzam, czy podany zosta poprawny kod licznika
      */
      EXECUTE PROCEDURE LN_CHECK_CODE :IdSystemu, :Rok, :KodLicznika RETURNING_VALUES :KodBledu;

      IF (KodBledu = 0) THEN
         EXCEPTION LN_EXC_INVALID_ID;


      KodBledu = 0;

      /*
      * usuwane s zapisy ze stosu
      */
      DELETE FROM LN_STOS WHERE id_systemu = :IdSystemu AND rok = :Rok AND kod = :KodLicznika;

      KodBledu = 1;
end^

ALTER PROCEDURE LN_GET_VALUE (IDSYSTEMU   Integer,
       ROK         Integer,
       KODLICZNIKA Varchar(2))
returns (WARTOSC Integer)
AS 
  declare variable GlWartosc INTEGER;
  declare variable Stos INTEGER;
begin

      Wartosc = -1;

      SELECT glowny FROM LN_LICZNIKI 
      WHERE id_systemu = :IdSystemu AND rok = :Rok AND kod = :KodLicznika
      INTO :GlWartosc;

      /*
      * jeeli zmienna GlWartosc jest rwna NULL, to przekazany zosta
      * kod nie istniejcego licznika
      */
      IF (GlWartosc IS NULL) THEN
         EXCEPTION LN_EXC_INVALID_ID;

      ELSE BEGIN

         /*
         * podaj najmniejsz warto przechowywan na stosie
         */
         SELECT MIN(wartosc) FROM LN_STOS
         WHERE id_systemu = :IdSystemu AND rok = :Rok AND kod = :KodLicznika AND stan = 0
         INTO :Stos;

         IF ((Stos IS NOT NULL) AND (Stos > 0)) THEN BEGIN
            UPDATE LN_STOS SET stan = 1
            WHERE id_systemu = :IdSystemu AND rok = :Rok AND kod = :KodLicznika AND stan = 0 AND wartosc = :Stos;

            Wartosc = Stos;

         END
         ELSE BEGIN
            /*
            * zwikszam gwn warto licznika (na stosie nie ma wolnych
            * numerw wybranego licznika)
            */
            GlWartosc = GlWartosc + 1;

            UPDATE LN_LICZNIKI SET glowny = :GlWartosc
            WHERE id_systemu = :IdSystemu AND rok = :Rok AND kod = :KodLicznika;

            INSERT INTO LN_STOS(id_systemu,rok,kod,wartosc,stan) 
            VALUES (:IdSystemu, :Rok, :KodLicznika, :GlWartosc, 1);

            Wartosc = GlWartosc;

         END

         /****
         * przechwycenie bdw:
         * -615 : rekord zablokowany (dotyczy: UPDATE)
         * -803 : powtrzony klucz gwny (dotyczy: INSERT)
         * -913 : deadlock
         ****/
         WHEN SQLCODE -913, SQLCODE -803, SQLCODE -615 DO 
         BEGIN
            Wartosc = -1;
            EXCEPTION LN_EXC_NO_VALUE;
         END

      END
end^

ALTER PROCEDURE LN_SET_TO (IDSYSTEMU   Integer,
       ROK         Integer,
       KODLICZNIKA Varchar(2),
       WARTOSC     Integer)
returns (KODBLEDU Integer)
AS 

begin

      /*
      * warto licznika nie moe by mniejsza od zera
      */
      IF (Wartosc < 0) THEN
         Wartosc = 0;

      /*
      * sprawdzam, czy podany zosta poprawny kod licznika
      */
      EXECUTE PROCEDURE LN_CHECK_CODE :IdSystemu, :Rok, :KodLicznika RETURNING_VALUES :KodBledu;

      IF (KodBledu = 0) THEN
         EXCEPTION LN_EXC_INVALID_ID;

      KodBledu = 0;

      /*
      * pierwszy krok - usuwane s wszystkie wartoci ze stosu
      */
      DELETE FROM LN_STOS WHERE id_systemu = :IdSystemu AND rok = :Rok AND kod = :KodLicznika;

      /*
      * drugi krok - ustawiana jest warto gwna licznika
      */
      UPDATE LN_LICZNIKI SET glowny = :Wartosc 
      WHERE id_systemu = :IdSystemu AND rok = :Rok AND kod = :KodLicznika;

      KodBledu = 1;
end^

ALTER PROCEDURE OP_ALLOPER 
returns (KOD_OPER   Smallint,
         NAZWA      Varchar(20),
         HASLO      Varchar(30),
         OPIS       Varchar(100),
         NAZWA_ZEWN Varchar(50),
         STATUS     Char(1))
AS 

begin
 KOD_OPER = 0;
 NAZWA ='Wszyscy operatorzy';
 HASLO = NULL;
 OPIS = 'Kod operatora 0 oznacza wybr wszystkich operatorw';
 NAZWA_ZEWN = NULL;
 STATUS = 'A';
 SUSPEND;
 FOR SELECT KOD_OPER, NAZWA, HASLO, OPIS, NAZWA_ZEWN, STATUS FROM OP_OPER
 ORDER BY KOD_OPER
 INTO :KOD_OPER, :NAZWA, :HASLO, :OPIS, :NAZWA_ZEWN, :STATUS
 DO
 BEGIN
 SUSPEND;
 END
end^

ALTER PROCEDURE OP_ALLRIGHTS (ID_SYSTEMU Integer,
       ID_OPER    Integer)
returns (KOD_FUN Char(5))
AS 

begin

   FOR
     SELECT KOD_FUNSYS FROM OP_SLFUN
     WHERE  KOD_SYSTEMU = :ID_SYSTEMU AND
            KOD_FUNSYS IN (SELECT KOD_FUNSYS FROM OP_GRFUN
            WHERE KOD_GRUPY IN ( SELECT KOD_GRUPY
                                 FROM OP_OPERGRUP
                                 WHERE KOD_OPER = :ID_OPER ) )
            OR
            KOD_FUNSYS LIKE "$%" AND
            KOD_FUNSYS IN (SELECT KOD_FUNSYS FROM OP_GRFUN
            WHERE KOD_GRUPY IN ( SELECT KOD_GRUPY
                                 FROM OP_OPERGRUP
                                 WHERE KOD_OPER = :ID_OPER ) )
     INTO :KOD_FUN 
   DO
     SUSPEND ;

   FOR
     SELECT KOD_FUNSYS FROM OP_SLFUN
     WHERE  KOD_SYSTEMU = :ID_SYSTEMU AND
            KOD_FUNSYS IN (SELECT KOD_FUNSYS FROM OP_OPFUN
                           WHERE KOD_OPER = :ID_OPER )
            OR
            KOD_FUNSYS LIKE "$%" AND
            KOD_FUNSYS IN (SELECT KOD_FUNSYS FROM OP_OPFUN
                           WHERE KOD_OPER = :ID_OPER )
     INTO :KOD_FUN 
   DO
     SUSPEND ;
end^

CREATE OR ALTER TRIGGER BO_TRG_ADRES_UPD_BEF FOR BO_ADRES
ACTIVE BEFORE UPDATE POSITION 0
AS

begin
IF (NEW.MIASTO <> OLD.MIASTO OR NEW.ULICA <> OLD.ULICA OR
NEW.DOM    <> OLD.DOM    OR NEW.LOKAL <> OLD.LOKAL) THEN
BEGIN
NEW.LCHG_DATA  = 'NOW';
NEW.LCHG_VALUE = OLD.MIASTO || ', ' || OLD.ULICA || ' ' || OLD.DOM || ' ' || OLD.LOKAL;
END 

end^

CREATE OR ALTER TRIGGER BO_TRG_ADRES_UP_IU FOR BO_ADRES
ACTIVE BEFORE  INSERT OR UPDATE POSITION 0
AS

begin
 NEW.MIASTO_UP = UPPER( NEW.MIASTO );
 NEW.ULICA_UP  = UPPER( NEW.ULICA );
 NEW.DOM_UP    = UPPER( NEW.DOM );

end^

CREATE OR ALTER TRIGGER BO_TRG_FIZ_UPD_BEF FOR BO_FIZ
ACTIVE BEFORE UPDATE POSITION 0
AS

begin
IF (NEW.NAZWISKO <> OLD.NAZWISKO OR NEW.IMIE <> OLD.IMIE) THEN
BEGIN
NEW.LCHG_DATA  = 'NOW';
NEW.LCHG_VALUE = OLD.NAZWISKO || ' ' || OLD.IMIE;
END 

end^

CREATE OR ALTER TRIGGER BO_TRG_FIZ_UP_IU FOR BO_FIZ
ACTIVE BEFORE  INSERT OR UPDATE POSITION 0
AS

begin
 NEW.NAZWISKO_UP = UPPER( NEW.NAZWISKO );
 NEW.IMIE_UP     = UPPER( NEW.IMIE );

end^

CREATE OR ALTER TRIGGER BO_TRG_MAIN_INS_BEF FOR BO_MAIN
ACTIVE BEFORE INSERT POSITION 0
AS

begin
NEW.CHG_DATA = 'NOW';

end^

CREATE OR ALTER TRIGGER BO_TRG_MAIN_UP_IU FOR BO_MAIN
ACTIVE BEFORE  INSERT OR UPDATE POSITION 0
AS

begin
 NEW.NAZWA_UP = UPPER( NEW.NAZWA );

end^

CREATE OR ALTER TRIGGER BO_TRG_MALZ_UPD_BEF FOR BO_MALZ
ACTIVE BEFORE UPDATE POSITION 0
AS

begin
IF (NEW.NAZWA <> OLD.NAZWA) THEN
BEGIN
NEW.LCHG_DATA  = 'NOW';
NEW.LCHG_VALUE = OLD.NAZWA;
END 

end^

CREATE OR ALTER TRIGGER BO_TRG_MALZ_UP_IU FOR BO_MALZ
ACTIVE BEFORE  INSERT OR UPDATE POSITION 0
AS

begin
 NEW.NAZWA_MLZ_UP = UPPER( NEW.NAZWA );

end^

CREATE OR ALTER TRIGGER BO_TRG_PRAWNE_UPD_BEF FOR BO_PRAWNE
ACTIVE BEFORE UPDATE POSITION 0
AS

begin
IF (NEW.NAZWA_SKR <> OLD.NAZWA_SKR OR NEW.NAZWA <> OLD.NAZWA) THEN
BEGIN
NEW.LCHG_DATA  = 'NOW';
NEW.LCHG_VALUE = OLD.NAZWA_SKR || ': ' || OLD.NAZWA;
END 

end^

CREATE OR ALTER TRIGGER BO_TRG_PRAWNE_UP_IU FOR BO_PRAWNE
ACTIVE BEFORE  INSERT OR UPDATE POSITION 0
AS

begin
 NEW.NAZWA_PLN_UP = UPPER( SUBSTRING( NEW.NAZWA FROM 1 FOR 80 ) );
 NEW.NAZWA_SKR_UP = UPPER( NEW.NAZWA_SKR );

end^

ALTER TRIGGER LZ_TRG_LOG_INS_BEF/* TABLE: "LZ_LOG" */
ACTIVE BEFORE INSERT POSITION 0
AS

begin
 IF (new.id_log IS NULL) THEN new.id_log = GEN_ID(LZ_GEN_LOG_ID,1); 

end^

SET TERM ; ^



commit work;
COMMENT ON COLUMN BO_ADRES.LCHG_VALUE IS '';
COMMENT ON COLUMN BO_FIZ.LCHG_VALUE IS '';
COMMENT ON COLUMN BO_FIZ.IMIE_DRUGIE IS '';
COMMENT ON COLUMN BO_FIZ.IMIE_MATKI IS '';
COMMENT ON COLUMN BO_FIZ.IMIE_OJCA IS '';
COMMENT ON COLUMN BO_PRAWNE.PKD IS '';
COMMENT ON COLUMN BO_PRAWNE.EKD IS '';
COMMENT ON COLUMN BO_PRAWNE.WWW IS '';
COMMENT ON COLUMN BO_PRAWNE.NAZWA_SKR IS '';
COMMENT ON COLUMN BO_PRAWNE.NAZWA IS '';
COMMENT ON COLUMN BO_PRAWNE.LCHG_VALUE IS '';
COMMENT ON COLUMN IS_REJESTR.NAZWA IS '';
COMMENT ON COLUMN IS_REJESTR.OPIS IS '';
COMMENT ON COLUMN IS_REJESTR.PATH IS '';
COMMENT ON COLUMN IS_REJESTR.PARAMS IS '';
COMMENT ON COLUMN IS_REJESTR.ACT_KEY IS '';
COMMENT ON COLUMN LZ_LOG.OPIS IS '';
COMMENT ON COLUMN OP_GRUPY.NAZWA IS '';
COMMENT ON COLUMN OP_GRUPY.OPIS IS '';
COMMENT ON COLUMN OP_OPER.NAZWA IS '';
COMMENT ON COLUMN OP_OPER.OPIS IS '';
COMMENT ON COLUMN OP_OPER.NAZWA_ZEWN IS '';
COMMENT ON COLUMN OP_SLFUN.OPIS IS '';